// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from stubborn_buddies_msgs:msg/Heartbeat.idl
// generated code does not contain a copyright notice
#include "stubborn_buddies_msgs/msg/detail/heartbeat__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `stamp`
#include "builtin_interfaces/msg/detail/time__functions.h"

bool
stubborn_buddies_msgs__msg__Heartbeat__init(stubborn_buddies_msgs__msg__Heartbeat * msg)
{
  if (!msg) {
    return false;
  }
  // stamp
  if (!builtin_interfaces__msg__Time__init(&msg->stamp)) {
    stubborn_buddies_msgs__msg__Heartbeat__fini(msg);
    return false;
  }
  // checkpoint_id
  msg->checkpoint_id = 0;
  return true;
}

void
stubborn_buddies_msgs__msg__Heartbeat__fini(stubborn_buddies_msgs__msg__Heartbeat * msg)
{
  if (!msg) {
    return;
  }
  // stamp
  builtin_interfaces__msg__Time__fini(&msg->stamp);
  // checkpoint_id
}

bool
stubborn_buddies_msgs__msg__Heartbeat__are_equal(const stubborn_buddies_msgs__msg__Heartbeat * lhs, const stubborn_buddies_msgs__msg__Heartbeat * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // stamp
  if (!builtin_interfaces__msg__Time__are_equal(
      &(lhs->stamp), &(rhs->stamp)))
  {
    return false;
  }
  // checkpoint_id
  if (lhs->checkpoint_id != rhs->checkpoint_id) {
    return false;
  }
  return true;
}

bool
stubborn_buddies_msgs__msg__Heartbeat__copy(
  const stubborn_buddies_msgs__msg__Heartbeat * input,
  stubborn_buddies_msgs__msg__Heartbeat * output)
{
  if (!input || !output) {
    return false;
  }
  // stamp
  if (!builtin_interfaces__msg__Time__copy(
      &(input->stamp), &(output->stamp)))
  {
    return false;
  }
  // checkpoint_id
  output->checkpoint_id = input->checkpoint_id;
  return true;
}

stubborn_buddies_msgs__msg__Heartbeat *
stubborn_buddies_msgs__msg__Heartbeat__create()
{
  stubborn_buddies_msgs__msg__Heartbeat * msg = (stubborn_buddies_msgs__msg__Heartbeat *)malloc(sizeof(stubborn_buddies_msgs__msg__Heartbeat));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(stubborn_buddies_msgs__msg__Heartbeat));
  bool success = stubborn_buddies_msgs__msg__Heartbeat__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
stubborn_buddies_msgs__msg__Heartbeat__destroy(stubborn_buddies_msgs__msg__Heartbeat * msg)
{
  if (msg) {
    stubborn_buddies_msgs__msg__Heartbeat__fini(msg);
  }
  free(msg);
}


bool
stubborn_buddies_msgs__msg__Heartbeat__Sequence__init(stubborn_buddies_msgs__msg__Heartbeat__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  stubborn_buddies_msgs__msg__Heartbeat * data = NULL;
  if (size) {
    data = (stubborn_buddies_msgs__msg__Heartbeat *)calloc(size, sizeof(stubborn_buddies_msgs__msg__Heartbeat));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = stubborn_buddies_msgs__msg__Heartbeat__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        stubborn_buddies_msgs__msg__Heartbeat__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
stubborn_buddies_msgs__msg__Heartbeat__Sequence__fini(stubborn_buddies_msgs__msg__Heartbeat__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      stubborn_buddies_msgs__msg__Heartbeat__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

stubborn_buddies_msgs__msg__Heartbeat__Sequence *
stubborn_buddies_msgs__msg__Heartbeat__Sequence__create(size_t size)
{
  stubborn_buddies_msgs__msg__Heartbeat__Sequence * array = (stubborn_buddies_msgs__msg__Heartbeat__Sequence *)malloc(sizeof(stubborn_buddies_msgs__msg__Heartbeat__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = stubborn_buddies_msgs__msg__Heartbeat__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
stubborn_buddies_msgs__msg__Heartbeat__Sequence__destroy(stubborn_buddies_msgs__msg__Heartbeat__Sequence * array)
{
  if (array) {
    stubborn_buddies_msgs__msg__Heartbeat__Sequence__fini(array);
  }
  free(array);
}

bool
stubborn_buddies_msgs__msg__Heartbeat__Sequence__are_equal(const stubborn_buddies_msgs__msg__Heartbeat__Sequence * lhs, const stubborn_buddies_msgs__msg__Heartbeat__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!stubborn_buddies_msgs__msg__Heartbeat__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
stubborn_buddies_msgs__msg__Heartbeat__Sequence__copy(
  const stubborn_buddies_msgs__msg__Heartbeat__Sequence * input,
  stubborn_buddies_msgs__msg__Heartbeat__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(stubborn_buddies_msgs__msg__Heartbeat);
    stubborn_buddies_msgs__msg__Heartbeat * data =
      (stubborn_buddies_msgs__msg__Heartbeat *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!stubborn_buddies_msgs__msg__Heartbeat__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          stubborn_buddies_msgs__msg__Heartbeat__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!stubborn_buddies_msgs__msg__Heartbeat__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
